/*
 * xp_speed.c
 * speed callback function
 */
 
#include <stdio.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/notify.h>
#include "xplayer.h"

/*
 * Custom externs
 */
 
extern void	au_playall();	/* xp_sound.c			*/
extern void	au_stop();	/* xp_sound.c			*/

/* 
 * Set the period of the playing function
 */

void	speed(speed)
int	speed;
{
  static	struct itimerval	timer;
  static	int			speed_prec = -1;

  if(speed == speed_prec)
    return;
  else
    speed_prec = speed;
    
  au_stop();

  xv_set(Time_popup_pop_time->sld_speed,
		PANEL_VALUE, speed,
		NULL);

  if((speed > 0) && (speed <= 100))
  {
    timer.it_value.tv_usec = (101 - speed) * 9000;
    timer.it_interval.tv_usec = (101 - speed) * 9000;
    notify_set_itimer_func(Xplayer_win_xplayer->win_xplayer,
   			   au_playall,
   			   ITIMER_REAL,
			   &timer,
			   NULL);
    if(speed < 75)
      xv_set(Time_popup_pop_time->set_speed,
			PANEL_VALUE, 1,
			NULL);
    else
      xv_set(Time_popup_pop_time->set_speed,
			PANEL_VALUE, 2,
			NULL);
  }
  else if(speed == 0)
  {
    /* Select "Stop" setting					*/
    xv_set(Time_popup_pop_time->set_speed,
		PANEL_VALUE, 0,
		NULL);

    notify_set_itimer_func(Xplayer_win_xplayer->win_xplayer,
   			   NOTIFY_FUNC_NULL,
   		 	   ITIMER_REAL,
			   NULL,
			   NULL);
  }
}
